# coding: utf-8
# Copyright (C) 2023 Ilia Kurochkin <brothermechanic@yandex.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
'''
DESCRIPTION.
PLY mesh exporter.
'''
__version__ = "0.2"

import bpy
from blender.export import export_decorator


@export_decorator
def export_ply(**kwargs):
    outpath = ('{}.ply'.format(kwargs['outpath']))

    bpy.ops.export_mesh.ply(filepath=outpath,
                            check_existing=False,
                            filter_glob="*.ply",
                            use_ascii=True,
                            use_selection=True,
                            use_mesh_modifiers=True,
                            use_normals=True,
                            use_uv_coords=True,
                            use_colors=True,
                            global_scale=kwargs['global_scale'],
                            axis_forward=kwargs['axis_forward'],
                            axis_up=kwargs['axis_up'])

    return outpath
